# aodh

## alarm create

Create an alarm

    openstack alarm create
        --name <NAME>
        -t <TYPE>
        [--project-id <PROJECT_ID>]
        [--user-id <USER_ID>]
        [--description <DESCRIPTION>]
        [--state <STATE>]
        [--severity <SEVERITY>]
        [--enabled {True|False}]
        [--alarm-action <Webhook URL>]
        [--ok-action <Webhook URL>]
        [--insufficient-data-action <Webhook URL>]
        [--time-constraint <Time Constraint>]
        [--repeat-actions {True|False}]
        [--query <QUERY>]
        [--comparison-operator <OPERATOR>]
        [--evaluation-periods <EVAL_PERIODS>]
        [--threshold <THRESHOLD>]
        [--event-type <EVENT_TYPE>]
        [-m <METER NAME>]
        [--period <PERIOD>]
        [--statistic <STATISTIC>]
        [--granularity <GRANULARITY>]
        [--aggregation-method <AGGR_METHOD>]
        [--metric <METRIC>]
        [--resource-type <RESOURCE_TYPE>]
        [--resource-id <RESOURCE_ID>]
        [--composite-rule <COMPOSITE_RULE>]
        [--stack-id <STACK_NAME_OR_ID>]
        [--pool-id <LOADBALANCER_POOL_NAME_OR_ID>]
        [--autoscaling-group-id <AUTOSCALING_GROUP_NAME_OR_ID>]

--name <NAME>

  Name of the alarm

-t <TYPE>, --type <TYPE>

  Type of alarm, should be one of: prometheus, event, composite, threshold, gnocchi_resources_threshold, gnocchi_aggregation_by_metrics_threshold, gnocchi_aggregation_by_resources_threshold, loadbalancer_member_health.

--project-id <PROJECT_ID>

  Project to associate with alarm (configurable by admin users only)

--user-id <USER_ID>

  User to associate with alarm (configurable by admin users only)

--description <DESCRIPTION>

  Free text description of the alarm

--state <STATE>

  State of the alarm, one of: [‘ok’, ‘alarm’, ‘insufficient data’]

--severity <SEVERITY>

  Severity of the alarm, one of: [‘low’, ‘moderate’, ‘critical’]

--enabled {True|False}

  True if alarm evaluation is enabled

--alarm-action <Webhook URL>

  URL to invoke when state transitions to alarm. May be used multiple times

--ok-action <Webhook URL>

  URL to invoke when state transitions to OK. May be used multiple times

--insufficient-data-action <Webhook URL>

  URL to invoke when state transitions to insufficient data. May be used multiple times

--time-constraint <Time Constraint>

  Only evaluate the alarm if the time at evaluation is within this time constraint. Start point(s) of the constraint are specified with a cron expression, whereas its duration is given in seconds. Can be specified multiple times for multiple time constraints, format is: name=<CONSTRAINT_NAME>;start=<CRON>;duration=<SECONDS>;[description=<DESCRIPTION>;[timezone=<IANA Timezone>]]

--repeat-actions {True|False}

  True if actions should be repeatedly notified while alarm remains in target state

--query <QUERY>

  For alarms of type threshold or event: key[op]data_type::value; list. data_type is optional, but if supplied must be string, integer, float, or boolean. For alarms of type gnocchi_aggregation_by_resources_threshold: need to specify a complex query json string, like: {“and”: [{“=”: {“ended_at”: null}}, …]}. For alarms of type prometheus this should be valid PromQL query.

--comparison-operator <OPERATOR>

  Operator to compare with, one of: [‘lt’, ‘le’, ‘eq’, ‘ne’, ‘ge’, ‘gt’]

--evaluation-periods <EVAL_PERIODS>

  Number of periods to evaluate over

--threshold <THRESHOLD>

  Threshold to evaluate against.

--event-type <EVENT_TYPE>

  Event type to evaluate against

-m <METER NAME>, --meter-name <METER NAME>

  Meter to evaluate against

--period <PERIOD>

  Length of each period (seconds) to evaluate over.

--statistic <STATISTIC>

  Statistic to evaluate, one of: [‘max’, ‘min’, ‘avg’, ‘sum’, ‘count’]

--granularity <GRANULARITY>

  The time range in seconds over which to query.

--aggregation-method <AGGR_METHOD>

  The aggregation_method to compare to the threshold.

--metric <METRIC>, --metrics <METRIC>

  The metric id or name depending of the alarm type

--resource-type <RESOURCE_TYPE>

  The type of resource.

--resource-id <RESOURCE_ID>

  The id of a resource.

--composite-rule <COMPOSITE_RULE>

  Composite threshold rule with JSON format, the form can be a nested dict which combine threshold/gnocchi rules by “and”, “or”. For example, the form is like: {“or”:[RULE1, RULE2, {“and”: [RULE3, RULE4]}]}, The RULEx can be basic threshold rules but must include a “type” field, like this: {“threshold”: 0.8,”meter_name”:”cpu_util”,”type”:”threshold”}

--stack-id <STACK_NAME_OR_ID>

  Name or ID of the root / top level Heat stack containing the loadbalancer pool and members. An update will be triggered on the root Stack if an unhealthy member is detected in the loadbalancer pool.

--pool-id <LOADBALANCER_POOL_NAME_OR_ID>

  Name or ID of the loadbalancer pool for which the health of each member will be evaluated.

--autoscaling-group-id <AUTOSCALING_GROUP_NAME_OR_ID>

  ID of the Heat autoscaling group that contains the loadbalancer members. Unhealthy members will be marked as such before an update is triggered on the root stack.

This command is provided by the aodhclient plugin.

## alarm delete

Delete an alarm

    openstack alarm delete [--name <NAME>] [<ALARM ID or NAME>]

--name <NAME>

  Name of the alarm

ALARM ID or NAME

  ID or name of an alarm.

This command is provided by the aodhclient plugin.

## alarm list

List alarms

    openstack alarm list
        [--format-config-file FORMAT_CONFIG]
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--query
        QUERY
        |
        --filter <KEY1
        =VALUE1;KEY2=VALUE2...>]
        [--limit <LIMIT>]
        [--marker <MARKER>]
        [--sort <SORT_KEY:SORT_DIR>]

--format-config-file <FORMAT_CONFIG>

  Config file for the dict-to-csv formatter

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--query <QUERY>

  Rich query supported by aodh, e.g. project_id!=my-id user_id=foo or user_id=bar

--filter <KEY1=VALUE1;KEY2=VALUE2...>

  Filter parameters to apply on returned alarms.

--limit <LIMIT>

  Number of resources to return (Default is server default)

--marker <MARKER>

  Last item of the previous listing. Return the next results after this value,the supported marker is alarm_id.

--sort <SORT_KEY:SORT_DIR>

  Sort of resource attribute, e.g. name:asc

This command is provided by the aodhclient plugin.

## alarm metrics

Get Metrics

    openstack alarm metrics
        [--format-config-file FORMAT_CONFIG]
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]

--format-config-file <FORMAT_CONFIG>

  Config file for the dict-to-csv formatter

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

This command is provided by the aodhclient plugin.

## alarm quota set

Command base class for displaying data about a single object.

    openstack alarm quota set [--alarm ALARM] project

--alarm <ALARM>

  New value for the alarm quota. Value -1 means unlimited.

project

  Project ID.

This command is provided by the aodhclient plugin.

## alarm quota show

Show quota for a project

    openstack alarm quota show [--project PROJECT]

--project <PROJECT>

  Project ID. If not specified, get quota for the current project.

This command is provided by the aodhclient plugin.

## alarm show

Show an alarm

    openstack alarm show [--name <NAME>] [<ALARM ID or NAME>]

--name <NAME>

  Name of the alarm

ALARM ID or NAME

  ID or name of an alarm.

This command is provided by the aodhclient plugin.

## alarm state get

Get state of an alarm

    openstack alarm state get [--name <NAME>] [<ALARM ID or NAME>]

--name <NAME>

  Name of the alarm

ALARM ID or NAME

  ID or name of an alarm.

This command is provided by the aodhclient plugin.

## alarm state set

Set state of an alarm

    openstack alarm state set
        [--name <NAME>]
        --state <STATE>
        [<ALARM ID or NAME>]

--name <NAME>

  Name of the alarm

--state <STATE>

  State of the alarm, one of: [‘ok’, ‘alarm’, ‘insufficient data’]

ALARM ID or NAME

  ID or name of an alarm.

This command is provided by the aodhclient plugin.

## alarm update

Update an alarm

    openstack alarm update
        [--name <NAME>]
        [-t <TYPE>]
        [--project-id <PROJECT_ID>]
        [--user-id <USER_ID>]
        [--description <DESCRIPTION>]
        [--state <STATE>]
        [--severity <SEVERITY>]
        [--enabled {True|False}]
        [--alarm-action <Webhook URL>]
        [--ok-action <Webhook URL>]
        [--insufficient-data-action <Webhook URL>]
        [--time-constraint <Time Constraint>]
        [--repeat-actions {True|False}]
        [--query <QUERY>]
        [--comparison-operator <OPERATOR>]
        [--evaluation-periods <EVAL_PERIODS>]
        [--threshold <THRESHOLD>]
        [--event-type <EVENT_TYPE>]
        [-m <METER NAME>]
        [--period <PERIOD>]
        [--statistic <STATISTIC>]
        [--granularity <GRANULARITY>]
        [--aggregation-method <AGGR_METHOD>]
        [--metric <METRIC>]
        [--resource-type <RESOURCE_TYPE>]
        [--resource-id <RESOURCE_ID>]
        [--composite-rule <COMPOSITE_RULE>]
        [--stack-id <STACK_NAME_OR_ID>]
        [--pool-id <LOADBALANCER_POOL_NAME_OR_ID>]
        [--autoscaling-group-id <AUTOSCALING_GROUP_NAME_OR_ID>]
        [<ALARM ID or NAME>]

--name <NAME>

  Name of the alarm

-t <TYPE>, --type <TYPE>

  Type of alarm, should be one of: prometheus, event, composite, threshold, gnocchi_resources_threshold, gnocchi_aggregation_by_metrics_threshold, gnocchi_aggregation_by_resources_threshold, loadbalancer_member_health.

--project-id <PROJECT_ID>

  Project to associate with alarm (configurable by admin users only)

--user-id <USER_ID>

  User to associate with alarm (configurable by admin users only)

--description <DESCRIPTION>

  Free text description of the alarm

--state <STATE>

  State of the alarm, one of: [‘ok’, ‘alarm’, ‘insufficient data’]

--severity <SEVERITY>

  Severity of the alarm, one of: [‘low’, ‘moderate’, ‘critical’]

--enabled {True|False}

  True if alarm evaluation is enabled

--alarm-action <Webhook URL>

  URL to invoke when state transitions to alarm. May be used multiple times

--ok-action <Webhook URL>

  URL to invoke when state transitions to OK. May be used multiple times

--insufficient-data-action <Webhook URL>

  URL to invoke when state transitions to insufficient data. May be used multiple times

--time-constraint <Time Constraint>

  Only evaluate the alarm if the time at evaluation is within this time constraint. Start point(s) of the constraint are specified with a cron expression, whereas its duration is given in seconds. Can be specified multiple times for multiple time constraints, format is: name=<CONSTRAINT_NAME>;start=<CRON>;duration=<SECONDS>;[description=<DESCRIPTION>;[timezone=<IANA Timezone>]]

--repeat-actions {True|False}

  True if actions should be repeatedly notified while alarm remains in target state

--query <QUERY>

  For alarms of type threshold or event: key[op]data_type::value; list. data_type is optional, but if supplied must be string, integer, float, or boolean. For alarms of type gnocchi_aggregation_by_resources_threshold: need to specify a complex query json string, like: {“and”: [{“=”: {“ended_at”: null}}, …]}. For alarms of type prometheus this should be valid PromQL query.

--comparison-operator <OPERATOR>

  Operator to compare with, one of: [‘lt’, ‘le’, ‘eq’, ‘ne’, ‘ge’, ‘gt’]

--evaluation-periods <EVAL_PERIODS>

  Number of periods to evaluate over

--threshold <THRESHOLD>

  Threshold to evaluate against.

--event-type <EVENT_TYPE>

  Event type to evaluate against

-m <METER NAME>, --meter-name <METER NAME>

  Meter to evaluate against

--period <PERIOD>

  Length of each period (seconds) to evaluate over.

--statistic <STATISTIC>

  Statistic to evaluate, one of: [‘max’, ‘min’, ‘avg’, ‘sum’, ‘count’]

--granularity <GRANULARITY>

  The time range in seconds over which to query.

--aggregation-method <AGGR_METHOD>

  The aggregation_method to compare to the threshold.

--metric <METRIC>, --metrics <METRIC>

  The metric id or name depending of the alarm type

--resource-type <RESOURCE_TYPE>

  The type of resource.

--resource-id <RESOURCE_ID>

  The id of a resource.

--composite-rule <COMPOSITE_RULE>

  Composite threshold rule with JSON format, the form can be a nested dict which combine threshold/gnocchi rules by “and”, “or”. For example, the form is like: {“or”:[RULE1, RULE2, {“and”: [RULE3, RULE4]}]}, The RULEx can be basic threshold rules but must include a “type” field, like this: {“threshold”: 0.8,”meter_name”:”cpu_util”,”type”:”threshold”}

--stack-id <STACK_NAME_OR_ID>

  Name or ID of the root / top level Heat stack containing the loadbalancer pool and members. An update will be triggered on the root Stack if an unhealthy member is detected in the loadbalancer pool.

--pool-id <LOADBALANCER_POOL_NAME_OR_ID>

  Name or ID of the loadbalancer pool for which the health of each member will be evaluated.

--autoscaling-group-id <AUTOSCALING_GROUP_NAME_OR_ID>

  ID of the Heat autoscaling group that contains the loadbalancer members. Unhealthy members will be marked as such before an update is triggered on the root stack.

ALARM ID or NAME

  ID or name of an alarm.

This command is provided by the aodhclient plugin.

## alarm-history search

Show history for all alarms based on query

    openstack alarm-history search
        [--format-config-file FORMAT_CONFIG]
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--query QUERY]

--format-config-file <FORMAT_CONFIG>

  Config file for the dict-to-csv formatter

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--query <QUERY>

  Rich query supported by aodh, e.g. project_id!=my-id user_id=foo or user_id=bar

This command is provided by the aodhclient plugin.

## alarm-history show

Show history for an alarm

    openstack alarm-history show
        [--format-config-file FORMAT_CONFIG]
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--limit <LIMIT>]
        [--marker <MARKER>]
        [--sort <SORT_KEY:SORT_DIR>]
        <alarm-id>

--format-config-file <FORMAT_CONFIG>

  Config file for the dict-to-csv formatter

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--limit <LIMIT>

  Number of resources to return (Default is server default)

--marker <MARKER>

  Last item of the previous listing. Return the next results after this value,the supported marker is event_id.

--sort <SORT_KEY:SORT_DIR>

  Sort of resource attribute. e.g. timestamp:desc

alarm-id

  ID of an alarm

This command is provided by the aodhclient plugin.

## alarming capabilities list

List capabilities of alarming service

    openstack alarming capabilities list

This command is provided by the aodhclient plugin.

this page last updated: 2026-04-01 09:44:20

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.